module ElectricProfile

  class RespondentProfiler
    attr_accessor :questions, :profiler

    def initialize(atts)
      atts = atts.inject({}){ |memo, (k, v) | memo[k.to_sym] = v; memo }
      @questions = atts[:questions]
      @profiler = atts[:profiler]
    end

    def save
      if @id
        save_existing
      else
        save_new
      end
    end

    def self.find(profiler_id, user_id, locale)
      client = Client.new
      if client.fetch_respondent_profiler(profiler_id, user_id, locale)
        new client.data
      else
        raise StandardError, client.error
      end
    end

  end

end
